diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/channel-access-manager.h ns-3.44/src/wifi/model/channel-access-manager.h
--- ns-3.43/src/wifi/model/channel-access-manager.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/channel-access-manager.h	2025-03-09 16:55:49.783372600 -0700
@@ -15,6 +15,7 @@
 #include "ns3/event-id.h"
 #include "ns3/nstime.h"
 #include "ns3/object.h"
+#include "ns3/traced-callback.h"
 
 #include <algorithm>
 #include <map>
@@ -32,10 +33,11 @@
 class PhyListener;
 class Txop;
 class FrameExchangeManager;
+enum AcIndex : uint8_t; // opaque enum declaration
 
 /**
- * \brief Manage a set of ns3::Txop
- * \ingroup wifi
+ * @brief Manage a set of ns3::Txop
+ * @ingroup wifi
  *
  * Handle a set of independent ns3::Txop, each of which represents
  * a single DCF within a MAC stack. Each ns3::Txop has a priority
@@ -59,8 +61,8 @@
     ~ChannelAccessManager() override;
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -69,37 +71,37 @@
      * listener becomes the active listener and the previous active listener attached to another
      * PHY, if any, is deactivated.
      *
-     * \param phy the WifiPhy to listen to
+     * @param phy the WifiPhy to listen to
      */
     void SetupPhyListener(Ptr<WifiPhy> phy);
     /**
      * Remove current registered listener for PHY events on the given PHY.
      *
-     * \param phy the WifiPhy to listen to
+     * @param phy the WifiPhy to listen to
      */
     void RemovePhyListener(Ptr<WifiPhy> phy);
     /**
      * Deactivate current registered listener for PHY events on the given PHY. All notifications
      * but channel switch notifications coming from an inactive listener are ignored.
      *
-     * \param phy the WifiPhy to listen to
+     * @param phy the WifiPhy to listen to
      */
     void DeactivatePhyListener(Ptr<WifiPhy> phy);
     /**
      * Set the ID of the link this Channel Access Manager is associated with.
      *
-     * \param linkId the ID of the link this Channel Access Manager is associated with
+     * @param linkId the ID of the link this Channel Access Manager is associated with
      */
     void SetLinkId(uint8_t linkId);
     /**
      * Set up the Frame Exchange Manager.
      *
-     * \param feManager the Frame Exchange Manager
+     * @param feManager the Frame Exchange Manager
      */
     void SetupFrameExchangeManager(Ptr<FrameExchangeManager> feManager);
 
     /**
-     * \param txop a new Txop.
+     * @param txop a new Txop.
      *
      * The ChannelAccessManager does not take ownership of this pointer so, the callee
      * must make sure that the Txop pointer will stay valid as long
@@ -119,17 +121,17 @@
      * backoff regardless of the busy/idle state of the medium, as per Section 35.3.16.4 of
      * 802.11be D4.0.
      *
-     * \param txop the Txop requesting to generate a backoff
-     * \param hadFramesToTransmit whether packets available for transmission were queued just
+     * @param txop the Txop requesting to generate a backoff
+     * @param hadFramesToTransmit whether packets available for transmission were queued just
      *                            before the occurrence of the event triggering this call
-     * \param checkMediumBusy whether generation of backoff (also) depends on the busy/idle state
+     * @param checkMediumBusy whether generation of backoff (also) depends on the busy/idle state
      *                        of the medium
-     * \return true if backoff needs to be generated, false otherwise
+     * @return true if backoff needs to be generated, false otherwise
      */
     bool NeedBackoffUponAccess(Ptr<Txop> txop, bool hadFramesToTransmit, bool checkMediumBusy);
 
     /**
-     * \param txop a Txop
+     * @param txop a Txop
      *
      * Notify the ChannelAccessManager that a specific Txop needs access to the
      * medium. The ChannelAccessManager is then responsible for starting an access
@@ -142,9 +144,9 @@
      * Access will never be granted to the medium _before_
      * the time returned by this method.
      *
-     * \param ignoreNav flag whether NAV should be ignored
+     * @param ignoreNav flag whether NAV should be ignored
      *
-     * \returns the absolute time at which access could start to be granted
+     * @returns the absolute time at which access could start to be granted
      */
     Time GetAccessGrantStart(bool ignoreNav = false) const;
 
@@ -152,9 +154,9 @@
      * Return the time when the backoff procedure
      * started for the given Txop.
      *
-     * \param txop the Txop
+     * @param txop the Txop
      *
-     * \return the time when the backoff procedure started
+     * @return the time when the backoff procedure started
      */
     Time GetBackoffStartFor(Ptr<Txop> txop) const;
 
@@ -162,15 +164,20 @@
      * Return the time when the backoff procedure
      * ended (or will end) for the given Txop.
      *
-     * \param txop the Txop
+     * @param txop the Txop
      *
-     * \return the time when the backoff procedure ended (or will end)
+     * @return the time when the backoff procedure ended (or will end)
      */
     Time GetBackoffEndFor(Ptr<Txop> txop) const;
 
     /**
-     * \param qosTxop a QosTxop that needs to be disabled
-     * \param duration the amount of time during which the QosTxop is disabled
+     * @return the time until the NAV has been set
+     */
+    Time GetNavEnd() const;
+
+    /**
+     * @param qosTxop a QosTxop that needs to be disabled
+     * @param duration the amount of time during which the QosTxop is disabled
      *
      * Disable the given EDCA for the given amount of time. This EDCA will not be
      * granted channel access during this period and the backoff timer will be frozen.
@@ -184,12 +191,12 @@
      * the right to start a TXOP but it does not transmit any frame (e.g., due to constraints
      * associated with EMLSR operations), provided that the queue is not actually empty.
      *
-     * \param enable whether to enable backoff generation when no TX is performed in a TXOP
+     * @param enable whether to enable backoff generation when no TX is performed in a TXOP
      */
     void SetGenerateBackoffOnNoTx(bool enable);
 
     /**
-     * \return whether the backoff should be invoked when an AC gains the right to start a TXOP
+     * @return whether the backoff should be invoked when an AC gains the right to start a TXOP
      *         but it does not transmit any frame (e.g., due to constraints associated with EMLSR
      *         operations), provided that the queue is not actually empty
      */
@@ -200,22 +207,22 @@
      * given time interval before the given time, if any primary channel has been
      * idle, or zero, otherwise.
      *
-     * \param interval the given time interval
-     * \param end the given end time
-     * \return the width of the largest primary channel that has been idle for the given time
+     * @param interval the given time interval
+     * @param end the given end time
+     * @return the width of the largest primary channel that has been idle for the given time
      * interval before the given time, if any primary channel has been idle, or zero, otherwise
      */
     MHz_u GetLargestIdlePrimaryChannel(Time interval, Time end);
 
     /**
-     * \param indices a set of indices (starting at 0) specifying the 20 MHz channels to test
-     * \return true if per-20 MHz CCA indicates busy for at least one of the
+     * @param indices a set of indices (starting at 0) specifying the 20 MHz channels to test
+     * @return true if per-20 MHz CCA indicates busy for at least one of the
      *         specified 20 MHz channels, false otherwise
      */
     bool GetPer20MHzBusy(const std::set<uint8_t>& indices) const;
 
     /**
-     * \param duration expected duration of reception
+     * @param duration expected duration of reception
      *
      * Notify the Txop that a packet reception started
      * for the expected duration.
@@ -232,7 +239,7 @@
      */
     void NotifyRxEndErrorNow();
     /**
-     * \param duration expected duration of transmission
+     * @param duration expected duration of transmission
      *
      * Notify the Txop that a packet transmission was
      * just started and is expected to last for the specified
@@ -240,9 +247,9 @@
      */
     void NotifyTxStartNow(Time duration);
     /**
-     * \param duration expected duration of CCA busy period
-     * \param channelType the channel type for which the CCA busy state is reported.
-     * \param per20MhzDurations vector that indicates for how long each 20 MHz subchannel
+     * @param duration expected duration of CCA busy period
+     * @param channelType the channel type for which the CCA busy state is reported.
+     * @param per20MhzDurations vector that indicates for how long each 20 MHz subchannel
      *        (corresponding to the index of the element in the vector) is busy and where a zero
      * duration indicates that the subchannel is idle. The vector is non-empty if  the PHY supports
      * 802.11ax or later and if the operational channel width is larger than 20 MHz.
@@ -253,8 +260,8 @@
                                WifiChannelListType channelType,
                                const std::vector<Time>& per20MhzDurations);
     /**
-     * \param phyListener the PHY listener that sent this notification
-     * \param duration expected duration of channel switching period
+     * @param phyListener the PHY listener that sent this notification
+     * @param duration expected duration of channel switching period
      *
      * Notify the Txop that a channel switching period has just started.
      * During switching state, new packets can be enqueued in Txop/QosTxop
@@ -278,13 +285,13 @@
      */
     void NotifyOnNow();
     /**
-     * \param duration the value of the received NAV.
+     * @param duration the value of the received NAV.
      *
      * Called at end of RX
      */
     void NotifyNavResetNow(Time duration);
     /**
-     * \param duration the value of the received NAV.
+     * @param duration the value of the received NAV.
      *
      * Called at end of RX
      */
@@ -292,7 +299,7 @@
     /**
      * Notify that ack timer has started for the given duration.
      *
-     * \param duration the duration of the timer
+     * @param duration the duration of the timer
      */
     void NotifyAckTimeoutStartNow(Time duration);
     /**
@@ -302,7 +309,7 @@
     /**
      * Notify that CTS timer has started for the given duration.
      *
-     * \param duration the duration of the timer
+     * @param duration the duration of the timer
      */
     void NotifyCtsTimeoutStartNow(Time duration);
     /**
@@ -314,7 +321,7 @@
      * Check if the device is busy sending or receiving,
      * or NAV or CCA busy.
      *
-     * \return true if the device is busy,
+     * @return true if the device is busy,
      *         false otherwise
      */
     bool IsBusy() const;
@@ -326,7 +333,7 @@
     /**
      * Reset the backoff for the given DCF/EDCAF.
      *
-     * \param txop the given DCF/EDCAF
+     * @param txop the given DCF/EDCAF
      */
     void ResetBackoff(Ptr<Txop> txop);
 
@@ -340,9 +347,9 @@
      * used by the given link. This notification is sent by the EMLSR Manager when a PHY object
      * switches operating channel to operate on another link.
      *
-     * \param phy the PHY object that is going to switch channel
-     * \param channel the new operating channel of the given PHY
-     * \param linkId the ID of the link on which the given PHY is going to operate
+     * @param phy the PHY object that is going to switch channel
+     * @param channel the new operating channel of the given PHY
+     * @param linkId the ID of the link on which the given PHY is going to operate
      */
     void NotifySwitchingEmlsrLink(Ptr<WifiPhy> phy,
                                   const WifiPhyOperatingChannel& channel,
@@ -356,8 +363,8 @@
     /**
      * Get current registered listener for PHY events on the given PHY.
      *
-     * \param phy the given PHY
-     * \return the current registered listener for PHY events on the given PHY
+     * @param phy the given PHY
+     * @return the current registered listener for PHY events on the given PHY
      */
     std::shared_ptr<PhyListener> GetPhyListener(Ptr<WifiPhy> phy) const;
 
@@ -382,10 +389,10 @@
      * This overload is provided to enable caching the value returned by GetAccessGrantStart(),
      * which is independent of the given Txop object.
      *
-     * \param txop the Txop
-     * \param accessGrantStart the value returned by GetAccessGrantStart()
+     * @param txop the Txop
+     * @param accessGrantStart the value returned by GetAccessGrantStart()
      *
-     * \return the time when the backoff procedure started
+     * @return the time when the backoff procedure started
      */
     Time GetBackoffStartFor(Ptr<Txop> txop, Time accessGrantStart) const;
 
@@ -393,10 +400,10 @@
      * This overload is provided to enable caching the value returned by GetAccessGrantStart(),
      * which is independent of the given Txop object.
      *
-     * \param txop the Txop
-     * \param accessGrantStart the value returned by GetAccessGrantStart()
+     * @param txop the Txop
+     * @param accessGrantStart the value returned by GetAccessGrantStart()
      *
-     * \return the time when the backoff procedure ended (or will end)
+     * @return the time when the backoff procedure ended (or will end)
      */
     Time GetBackoffEndFor(Ptr<Txop> txop, Time accessGrantStart) const;
 
@@ -427,21 +434,21 @@
     /**
      * Return the Short Interframe Space (SIFS) for this PHY.
      *
-     * \return the SIFS duration
+     * @return the SIFS duration
      */
     virtual Time GetSifs() const;
 
     /**
      * Return the slot duration for this PHY.
      *
-     * \return the slot duration
+     * @return the slot duration
      */
     virtual Time GetSlot() const;
 
     /**
      * Return the EIFS duration minus a DIFS.
      *
-     * \return the EIFS duration minus a DIFS
+     * @return the EIFS duration minus a DIFS
      */
     virtual Time GetEifsNoDifs() const;
 
@@ -501,6 +508,23 @@
     Ptr<WifiPhy> m_phy;                    //!< pointer to the unique active PHY
     Ptr<FrameExchangeManager> m_feManager; //!< pointer to the Frame Exchange Manager
     uint8_t m_linkId;                      //!< the ID of the link this object is associated with
+    uint8_t m_nSlotsLeft;                  //!< fire the NSlotsLeftAlert trace source when the
+                                           //!< backoff counter with the minimum value among all
+                                           //!< ACs reaches this value
+
+    /**
+     * TracedCallback signature for NSlotsLeft alerts.
+     *
+     * @param linkId the ID of this link
+     * @param aci the index of the AC that triggered the NSlotsLeft alert
+     * @param backoffDelay delay until backoff counts down to zero
+     */
+    typedef void (*NSlotsLeftCallback)(uint8_t linkId, AcIndex aci, const Time& backoffDelay);
+
+    /// TracedCallback for NSlotsLeft alerts typedef
+    using NSlotsLeftTracedCallback = TracedCallback<uint8_t, AcIndex, const Time&>;
+
+    NSlotsLeftTracedCallback m_nSlotsLeftCallback; //!< traced callback for NSlotsLeft alerts
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/ctrl-headers.cc ns-3.44/src/wifi/model/ctrl-headers.cc
--- ns-3.43/src/wifi/model/ctrl-headers.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/ctrl-headers.cc	2025-03-09 16:55:49.783372600 -0700
@@ -72,6 +72,9 @@
     case BlockAckReqType::MULTI_TID:
         size += (2 + 2) * (m_tidInfo + 1);
         break;
+    case BlockAckReqType::GCR:
+        size += (2 + 6); // SSC plus GCR Group Address
+        break;
     default:
         NS_FATAL_ERROR("Invalid BA type");
         break;
@@ -94,6 +97,10 @@
     case BlockAckReqType::MULTI_TID:
         NS_FATAL_ERROR("Multi-tid block ack is not supported.");
         break;
+    case BlockAckReqType::GCR:
+        i.WriteHtolsbU16(GetStartingSequenceControl());
+        WriteTo(i, m_gcrAddress);
+        break;
     default:
         NS_FATAL_ERROR("Invalid BA type");
         break;
@@ -115,6 +122,10 @@
     case BlockAckReqType::MULTI_TID:
         NS_FATAL_ERROR("Multi-tid block ack is not supported.");
         break;
+    case BlockAckReqType::GCR:
+        SetStartingSequenceControl(i.ReadLsbtohU16());
+        ReadFrom(i, m_gcrAddress);
+        break;
     default:
         NS_FATAL_ERROR("Invalid BA type");
         break;
@@ -139,6 +150,9 @@
     case BlockAckReqType::MULTI_TID:
         res |= (0x03 << 1);
         break;
+    case BlockAckReqType::GCR:
+        res |= (0x06 << 1);
+        break;
     default:
         NS_FATAL_ERROR("Invalid BA type");
         break;
@@ -151,7 +165,11 @@
 CtrlBAckRequestHeader::SetBarControl(uint16_t bar)
 {
     m_barAckPolicy = ((bar & 0x01) == 1);
-    if (((bar >> 1) & 0x0f) == 0x03)
+    if (((bar >> 1) & 0x0f) == 0x06)
+    {
+        m_barType.m_variant = BlockAckReqType::GCR;
+    }
+    else if (((bar >> 1) & 0x0f) == 0x03)
     {
         m_barType.m_variant = BlockAckReqType::MULTI_TID;
     }
@@ -231,6 +249,20 @@
     return m_startingSeq;
 }
 
+void
+CtrlBAckRequestHeader::SetGcrGroupAddress(const Mac48Address& address)
+{
+    NS_ASSERT(IsGcr());
+    m_gcrAddress = address;
+}
+
+Mac48Address
+CtrlBAckRequestHeader::GetGcrGroupAddress() const
+{
+    NS_ASSERT(IsGcr());
+    return m_gcrAddress;
+}
+
 bool
 CtrlBAckRequestHeader::IsBasic() const
 {
@@ -255,6 +287,12 @@
     return m_barType.m_variant == BlockAckReqType::MULTI_TID;
 }
 
+bool
+CtrlBAckRequestHeader::IsGcr() const
+{
+    return m_barType.m_variant == BlockAckReqType::GCR;
+}
+
 /***********************************
  *       Block ack response
  ***********************************/
@@ -323,6 +361,9 @@
     case BlockAckType::MULTI_TID:
         size += (2 + 2 + 8) * (m_tidInfo + 1); // Multi-TID block ack
         break;
+    case BlockAckType::GCR:
+        size += (2 + 6 + m_baType.m_bitmapLen[0]);
+        break;
     case BlockAckType::MULTI_STA:
         for (auto& bitmapLen : m_baType.m_bitmapLen)
         {
@@ -349,6 +390,11 @@
         i.WriteHtolsbU16(GetStartingSequenceControl());
         i = SerializeBitmap(i);
         break;
+    case BlockAckType::GCR:
+        i.WriteHtolsbU16(GetStartingSequenceControl());
+        WriteTo(i, m_baInfo[0].m_address);
+        i = SerializeBitmap(i);
+        break;
     case BlockAckType::MULTI_STA:
         for (std::size_t index = 0; index < m_baInfo.size(); index++)
         {
@@ -365,7 +411,7 @@
             {
                 uint32_t reserved = 0;
                 i.WriteHtolsbU32(reserved);
-                WriteTo(i, m_baInfo[index].m_ra);
+                WriteTo(i, m_baInfo[index].m_address);
             }
         }
         break;
@@ -391,6 +437,11 @@
         SetStartingSequenceControl(i.ReadLsbtohU16());
         i = DeserializeBitmap(i);
         break;
+    case BlockAckType::GCR:
+        SetStartingSequenceControl(i.ReadLsbtohU16());
+        ReadFrom(i, m_baInfo[0].m_address);
+        i = DeserializeBitmap(i);
+        break;
     case BlockAckType::MULTI_STA: {
         std::size_t index = 0;
         while (i.GetRemainingSize() > 0)
@@ -414,7 +465,7 @@
             else
             {
                 i.ReadLsbtohU32(); // next 4 bytes are reserved
-                ReadFrom(i, m_baInfo.back().m_ra);
+                ReadFrom(i, m_baInfo.back().m_address);
                 // the length of this Per AID TID Info subfield is 12, so set
                 // the bitmap length to 8 to simulate the correct size
                 m_baType.m_bitmapLen.back() = 8;
@@ -450,7 +501,7 @@
         BaInfoInstance baInfoInstance{.m_aidTidInfo = 0,
                                       .m_startingSeq = 0,
                                       .m_bitmap = std::vector<uint8_t>(bitmapLen, 0),
-                                      .m_ra = Mac48Address()};
+                                      .m_address = Mac48Address()};
 
         m_baInfo.emplace_back(baInfoInstance);
     }
@@ -555,6 +606,12 @@
     return m_baType.m_variant == BlockAckType::MULTI_STA;
 }
 
+bool
+CtrlBAckResponseHeader::IsGcr() const
+{
+    return m_baType.m_variant == BlockAckType::GCR;
+}
+
 void
 CtrlBAckResponseHeader::SetAid11(uint16_t aid, std::size_t index)
 {
@@ -595,7 +652,7 @@
 {
     NS_ASSERT(GetAid11(index) == 2045);
 
-    m_baInfo[index].m_ra = ra;
+    m_baInfo[index].m_address = ra;
 }
 
 Mac48Address
@@ -603,7 +660,7 @@
 {
     NS_ASSERT(GetAid11(index) == 2045);
 
-    return m_baInfo[index].m_ra;
+    return m_baInfo[index].m_address;
 }
 
 std::size_t
@@ -630,6 +687,20 @@
     return ret;
 }
 
+void
+CtrlBAckResponseHeader::SetGcrGroupAddress(const Mac48Address& address)
+{
+    NS_ASSERT(IsGcr());
+    m_baInfo[0].m_address = address;
+}
+
+Mac48Address
+CtrlBAckResponseHeader::GetGcrGroupAddress() const
+{
+    NS_ASSERT(IsGcr());
+    return m_baInfo[0].m_address;
+}
+
 uint16_t
 CtrlBAckResponseHeader::GetBaControl() const
 {
@@ -651,6 +722,9 @@
     case BlockAckType::MULTI_TID:
         res |= (0x03 << 1);
         break;
+    case BlockAckType::GCR:
+        res |= (0x06 << 1);
+        break;
     case BlockAckType::MULTI_STA:
         res |= (0x0b << 1);
         break;
@@ -669,7 +743,11 @@
 CtrlBAckResponseHeader::SetBaControl(uint16_t ba)
 {
     m_baAckPolicy = ((ba & 0x01) == 1);
-    if (((ba >> 1) & 0x0f) == 0x03)
+    if (((ba >> 1) & 0x0f) == 0x06)
+    {
+        SetType(BlockAckType::GCR);
+    }
+    else if (((ba >> 1) & 0x0f) == 0x03)
     {
         SetType(BlockAckType::MULTI_TID);
     }
@@ -711,7 +789,7 @@
     // The Fragment Number subfield encodes the length of the bitmap for Compressed and Multi-STA
     // variants (see sections 9.3.1.8.2 and 9.3.1.8.7 of 802.11ax-2021 and 802.11be Draft 4.0).
     // Note that Fragmentation Level 3 is not supported.
-    if (m_baType.m_variant == BlockAckType::COMPRESSED)
+    if (m_baType.m_variant == BlockAckType::COMPRESSED || m_baType.m_variant == BlockAckType::GCR)
     {
         switch (m_baType.m_bitmapLen[0])
         {
@@ -774,7 +852,7 @@
     // The Fragment Number subfield encodes the length of the bitmap for Compressed and Multi-STA
     // variants (see sections 9.3.1.8.2 and 9.3.1.8.7 of 802.11ax-2021 and 802.11be Draft 4.0).
     // Note that Fragmentation Level 3 is not supported.
-    if (m_baType.m_variant == BlockAckType::COMPRESSED)
+    if (m_baType.m_variant == BlockAckType::COMPRESSED || m_baType.m_variant == BlockAckType::GCR)
     {
         uint16_t fragNumber = seqControl & 0x000f;
 
@@ -785,16 +863,16 @@
         switch (fragNumber)
         {
         case 0:
-            SetType({BlockAckType::COMPRESSED, {8}});
+            SetType({m_baType.m_variant, {8}});
             break;
         case 4:
-            SetType({BlockAckType::COMPRESSED, {32}});
+            SetType({m_baType.m_variant, {32}});
             break;
         case 8:
-            SetType({BlockAckType::COMPRESSED, {64}});
+            SetType({m_baType.m_variant, {64}});
             break;
         case 10:
-            SetType({BlockAckType::COMPRESSED, {128}});
+            SetType({m_baType.m_variant, {128}});
             break;
         default:
             NS_ABORT_MSG("Unsupported fragment number: " << fragNumber);
@@ -852,6 +930,7 @@
     case BlockAckType::BASIC:
     case BlockAckType::COMPRESSED:
     case BlockAckType::EXTENDED_COMPRESSED:
+    case BlockAckType::GCR:
     case BlockAckType::MULTI_STA:
         for (const auto& byte : m_baInfo[index].m_bitmap)
         {
@@ -881,6 +960,7 @@
     case BlockAckType::BASIC:
     case BlockAckType::COMPRESSED:
     case BlockAckType::EXTENDED_COMPRESSED:
+    case BlockAckType::GCR:
     case BlockAckType::MULTI_STA:
         for (uint8_t j = 0; j < m_baType.m_bitmapLen[index]; j++)
         {
@@ -917,6 +997,7 @@
         break;
     case BlockAckType::COMPRESSED:
     case BlockAckType::EXTENDED_COMPRESSED:
+    case BlockAckType::GCR:
     case BlockAckType::MULTI_STA: {
         uint16_t i = IndexInBitmap(seq, index);
         m_baInfo[index].m_bitmap[i / 8] |= (uint8_t(0x01) << (i % 8));
@@ -946,6 +1027,7 @@
         break;
     case BlockAckType::COMPRESSED:
     case BlockAckType::EXTENDED_COMPRESSED:
+    case BlockAckType::GCR:
     case BlockAckType::MULTI_STA:
         /* We can ignore this...compressed block ack doesn't support
            acknowledgment of single fragments */
@@ -983,6 +1065,7 @@
         return false;
     case BlockAckType::COMPRESSED:
     case BlockAckType::EXTENDED_COMPRESSED:
+    case BlockAckType::GCR:
     case BlockAckType::MULTI_STA: {
         uint16_t i = IndexInBitmap(seq, index);
         uint8_t mask = uint8_t(0x01) << (i % 8);
@@ -1013,6 +1096,7 @@
                0;
     case BlockAckType::COMPRESSED:
     case BlockAckType::EXTENDED_COMPRESSED:
+    case BlockAckType::GCR:
     case BlockAckType::MULTI_STA:
         /* We can ignore this...compressed block ack doesn't support
            acknowledgement of single fragments */
@@ -2052,7 +2136,7 @@
 MHz_u
 CtrlTriggerHeader::GetUlBandwidth() const
 {
-    return (1 << m_ulBandwidth) * 20;
+    return (1 << m_ulBandwidth) * MHz_u{20};
 }
 
 void
@@ -2182,6 +2266,12 @@
     return m_userInfoFields.back();
 }
 
+CtrlTriggerHeader::Iterator
+CtrlTriggerHeader::RemoveUserInfoField(ConstIterator userInfoIt)
+{
+    return m_userInfoFields.erase(userInfoIt);
+}
+
 CtrlTriggerHeader::ConstIterator
 CtrlTriggerHeader::begin() const
 {
